Network hardware performance: automated testing strategies
Measuring the performance of network cards, SmartNICs included, calls for repeatable tests, and a single RFC 2544 test can take approximately 56 minutes.
This walkthrough shows how CodiLime runs RFC 2544 tests with Cisco's TRex, from test topology to testing a SmartNIC layer by layer, then automates them in a CI/CD pipeline with Jenkins, Ansible and Docker and reports the results.
The main topics covered in this e-book:
- RFC 2544 test design with Cisco's TRex as the traffic generator
- Multi-server and single-server topologies: NUMA, CPU pinning, huge pages, queue mapping
- Layered SmartNIC testing with TestPMD and DPDK-l3fwd as traffic reflectors
- Test automation with Jenkins, Ansible, Docker, Pytest and PTF
- Sample throughput and PPS results for 64 to 1500-byte packets

Why download this e-book?
Which standards fit a network performance test?
The ebook compares RFC 2544, Y.1564 and RFC 6349, and covers latency measurement with RFC 5481. Most of its tests follow RFC 2544.
How do you build a test bed from open-source tools?
It designs the topology around Cisco's TRex traffic generator and TestPMD, and weighs bare metal against virtual machines and containers, which can disturb latency measurements.
How does a manual test become an automated one?
The ebook moves from manual tests to automation with Python scripts on the TRex API, Ansible to set up the environment and Jenkins to run the CI/CD pipeline, with quality gates before deployment.
How do results turn into decisions?
A chapter on report generation and analysis shows how to present test results so they support data-driven business decisions.
Related content
- ArticleSecurityAn AI firewall where the CPU never touches a packet
Benjamin Wharton7 min read
- ArticleAI & MLHow inline ML on an FPGA SmartNIC detects SYN floods at line rate
Benjamin Wharton6 min read
- ArticleHardwareWhy MQTT acceleration needs more than standard NIC offloads (and how SmartNICs do it differently)
Benjamin Wharton12 min read
- ArticleHardwareAn Introduction to SONiC-DASH
Yuriy Harhas13 min read
Ready to modernize?
Tell us where your data center is today, and we’ll take it from there — all the way to AI-ready.
